use xmpd_manifest::store::BaseStore;

use super::CompUi;

#[derive(Debug, Default)]
pub struct LeftNav;

component_register!(LeftNav);

impl CompUi for LeftNav {
    fn draw(ui: &mut egui::Ui, state: &mut crate::GuiState) -> crate::Result<()> {
        let height = ui.available_height();
        egui::ScrollArea::vertical().id_source("left_nav").show(ui, |ui| {
            //ui.horizontal(|ui| {
                ui.vertical(|ui| {
                    let playlists = state.manifest.store().get_playlists();
                    for (_pid, playlist) in playlists.iter() {
                        ui.horizontal(|ui| {
                            ui.add_space(5.0);
                            ui.add(
                                egui::Image::new(crate::data::NOTE_ICON)
                                    .tint(crate::data::C_ACCENT)
                                    .fit_to_exact_size(egui::Vec2::new(32.0, 32.0))
                            );
                            ui.label(playlist.name());
                            ui.with_layout(egui::Layout::bottom_up(egui::Align::RIGHT), |ui| {
                                ui.label(format!("{}", playlist.songs().len()));
                            }); 
                        });
                        ui.separator();
                    }
                });
            // });
        });
 
        Ok(())
    }
}


