
macro_rules! component_register {
    ($comp:ident) => {
        lazy_static::lazy_static! {
            static ref __COMPONENT: std::sync::Arc<std::sync::Mutex<$comp>> = 
                std::sync::Arc::new(std::sync::Mutex::new($comp::default()));
        }
        impl crate::components::CompGetter for $comp {
            fn get() -> crate::Result<std::sync::MutexGuard<'static, Self>> {
                match __COMPONENT.lock() {
                    Ok(l) => Ok(l),
                    Err(e) => Err(anyhow::anyhow!(format!("{e:?}"))),
                }
            }
        }
    };
}

macro_rules! handle_error_ui {
    ($val:expr) => {
        match $val {
            Ok(v) => v,
            Err(e) => {
                log::error!("Error in ui: {e:?}");
                return;
            }
        } 
    };
}
